#include <iostream.h>

#include <kapp.h>
#include <kconfig.h>
#include <kconfigbase.h>
#include <klocale.h>

#include <mywidget.h>
#include <configTab.h>

#include "mocConfigTab.cpp"


extern KLocale* loc;



void configTab::apply ()
{
  KConfig* k = KApplication::getKApplication()->getConfig();
  
  k->setGroup ("common");
  
  if ( startUp->rb1->isChecked () ) 
    {
      k->writeEntry ("windowSize", "minimum");
      emit (showMinimum ());
    }
  else if (startUp->rb2->isChecked ()) 
    {
      k->writeEntry ("windowSize","standard");
      emit (showStandard ());
    }
  else 
    {
      k->writeEntry ("windowSize", "full");
      emit (showFull ());
    }

  if (startUp->bar->isChecked () ) emit (showMenuBar ());
  else emit (hideMenuBar ());

  if (startUp->buttonbar->isChecked () ) emit (showToolBar ());
  else emit (hideToolBar ());

  if (exit->exitOnConnect->isChecked () ) 
    k->writeEntry ("exitOnConnect", "TRUE");
  else k->writeEntry ("exitOnConnect", "FALSE");

  if (exit->autosave->isChecked () )
    k->writeEntry ("autosaveOptions", "TRUE");
  else k->writeEntry ("autosaveOptions", "FALSE");

  if (exit->autosaveSessions->isChecked () )
    k->writeEntry ("autosaveSessions", "TRUE");
  else k->writeEntry ("autosaveSessions", "FALSE");

  if (exit->xhostbutton->isChecked () )
    k->writeEntry ("callXhost", "TRUE");
  else k->writeEntry ("callXhost", "FALSE");
}



configTab::configTab (QWidget* parent, const char* name, bool modal)
  : QTabDialog (0, name, modal)
{
  setCaption (loc->translate("Configure KTelnet"));
  resize (350, 340);

  startUp = new startUpWidget (this);
  exit = new exitWidget (this);

  addTab (startUp, loc->translate("Appearance"));
  addTab (exit, loc->translate("Further"));

  // 
  // set the buttons of the widgets now
  //

  KConfig* k = KApplication::getKApplication()->getConfig();
  k->setGroup ("common");  

  if (k->readEntry ("windowSize", "") == QString("minimum") ) 
    startUp->rb1->setChecked (TRUE);
  if (k->readEntry ("windowSize", "standard") == QString("standard") ) 
    startUp->rb2->setChecked (TRUE);
  if (k->readEntry ("windowSize", "") == QString("full") ) 
    startUp->rb3->setChecked (TRUE);

  if (k->readEntry ("showMenuBar", "TRUE") == QString("TRUE") ) 
    startUp->bar->setChecked (TRUE);
  else startUp->bar->setChecked (FALSE);

  if (k->readEntry ("showToolBar", "TRUE") == QString("TRUE") ) 
    startUp->buttonbar->setChecked (TRUE);
  else startUp->buttonbar->setChecked (FALSE);

  if (k->readEntry ("exitOnConnect", "FALSE") == QString("TRUE") ) 
    exit->exitOnConnect->setChecked (TRUE);
  else exit->exitOnConnect->setChecked (FALSE);

  if (k->readEntry ("autosaveOptions", "FALSE") == QString("TRUE") ) 
    exit->autosave->setChecked (TRUE);
  else exit->autosave->setChecked (FALSE);

  if (k->readEntry ("autosaveSessions", "FALSE") == QString("TRUE") ) 
    exit->autosaveSessions->setChecked (TRUE);
  else exit->autosaveSessions->setChecked (FALSE);
  
  if ( k->readEntry ("callXhost", "FALSE") == QString("TRUE") )
    exit->xhostbutton->setChecked (TRUE);
  else exit->xhostbutton->setChecked (FALSE);
  
  // now set the main buttons (Cancel and Apply)

  setCancelButton (loc->translate("Cancel"));
  setApplyButton (loc->translate("Apply"));

  connect (this, SIGNAL (applyButtonPressed ()), SLOT (apply()) );

  connect (this, SIGNAL (showMinimum()), parent, SLOT (showMinimum()));
  connect (this, SIGNAL (showStandard()), parent, SLOT (showStandard()));
  connect (this, SIGNAL (showFull()), parent, SLOT (showFull()));

  connect (this, SIGNAL (showMenuBar()), parent, SLOT (showMenuBar()));
  connect (this, SIGNAL (hideMenuBar()), parent, SLOT (hideMenuBar()));

  connect (this, SIGNAL (showToolBar()), parent, SLOT (showToolBar()));
  connect (this, SIGNAL (hideToolBar()), parent, SLOT (hideToolBar()));
}


configTab::~configTab ()
{
  delete startUp;
  delete exit;
}
